<?php
namespace CashBill\Payments\Helper;

use Magento\Framework\App\Helper\AbstractHelper;
use Magento\Store\Model\ScopeInterface;
use Magento\Sales\Model\Order;
use CashBill\Payments\Model\Library\Shop;
use CashBill\Payments\Model\Library\Model\Amount;
use CashBill\Payments\Model\Library\Model\PersonalData;
/**
 * Class Data.
 * @package CashBill\Payments\Helper
 */
final class Data extends AbstractHelper
{
    public function __construct(\Magento\Framework\App\Helper\Context $context)
    {
        parent::__construct($context);
    }

    public function createPayment(Order $order)
    {
        $shop = new Shop($this->getConfigData('cb_id'), $this->getConfigData('cb_secret'), $this->getConfigData('sandbox') != true);
        
        $amount = new Amount($this->roundToTwoDecimal($order->getGrandTotal()),$order->getOrderCurrencyCode());

        $personalData = new PersonalData ();
        $personalData->setEmail ( $order->getCustomerEmail() );
        
        $payment = $shop->createPayment("Zamówienie #".$order->getId(), $amount, "Płatność za zamówienie #", $order->getId(), $personalData, $this->_urlBuilder->getUrl('cashbill/checkout/success'), $this->_urlBuilder->getUrl('cashbill/checkout/failure'));

        return $payment;
    }

    public function getConfigData($field)
    {
        return $this->scopeConfig->getValue('payment/cashbill_payments/' . $field,
            ScopeInterface::SCOPE_STORE);
    }

    public function roundToTwoDecimal($price)
    {
        return number_format((float) $price, 2, '.', '');
    }

}
